'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  from {\n    height: 0;\n    width: 0;\n  }\n  to {\n    height: ', 'px;\n    width: ', 'px;\n  }\n'], ['\n  from {\n    height: 0;\n    width: 0;\n  }\n  to {\n    height: ', 'px;\n    width: ', 'px;\n  }\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  from {\n    height: ', 'px;\n    width: ', 'px;\n  }\n  to {\n    height: 0;\n    width: 0;\n  }\n'], ['\n  from {\n    height: ', 'px;\n    width: ', 'px;\n  }\n  to {\n    height: 0;\n    width: 0;\n  }\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  pointer-events: none;\n\n  ', '\n'], ['\n  pointer-events: none;\n\n  ', '\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['animation: ', ' ', ' ', ''], ['animation: ', ' ', ' ', '']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(['animation: 0.2s ', ' cubic-bezier(0.2, 0, 0, 1)'], ['animation: 0.2s ', ' cubic-bezier(0.2, 0, 0, 1)']);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _animation = require('../animation');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var animateIn = function animateIn(_ref) {
  var height = _ref.height,
      width = _ref.width;
  return (0, _styledComponents.keyframes)(_templateObject, height, width);
};

var animateOut = function animateOut(_ref2) {
  var height = _ref2.height,
      width = _ref2.width;
  return (0, _styledComponents.keyframes)(_templateObject2, height, width);
};

var AnimatedPlaceholder = _styledComponents2.default.div(_templateObject3, function (_ref3) {
  var height = _ref3.height,
      isAnimatingIn = _ref3.isAnimatingIn,
      isAnimatingOut = _ref3.isAnimatingOut,
      width = _ref3.width;

  if (isAnimatingIn) {
    return (0, _styledComponents.css)(_templateObject4, _animation.css.transitionTime, animateIn, _animation.css.transitionCurve);
  }

  if (isAnimatingOut) {
    return (0, _styledComponents.css)(_templateObject5, animateOut);
  }

  return '\n      height: ' + height + 'px;\n      width: ' + width + 'px;\n    ';
});
AnimatedPlaceholder.displayName = 'AnimatedPlaceholder';
exports.default = AnimatedPlaceholder;